// Programacin en C++ para Ingenieros, Ed. Thomson Paraninfo, 2006
// Captulo 10: Ficheros





// Inclusin de libreras
#include <iostream>
#include <fstream>
#include <string.h>

using namespace std;

// Declaracin de tipos
typedef char id[20];
typedef struct {
    id nombre, apellido;
    int edad;
}persona;

int main(void) 
{
    ifstream fEntrada;
    int pos;
    persona p;

    fEntrada.open("datosPersona.bin");

    if (!fEntrada)
        cout << "Error abriendo el fichero" << endl;
    else
    {
        cout << "Entra el nmero de persona a mostrar: ";
        cin >> pos;

        if ((pos - 1) * sizeof(persona) > 
                fEntrada.seekg(0, ios::end).tellg())
            cout << "Ese elemento no existe" << endl;
        else
        {
            // Nos ponemos en la posicin de la persona nmero pos
            fEntrada.seekg((pos - 1) * sizeof(persona));

            fEntrada.read((char*)(&p), sizeof(p));
            cout << p.nombre << endl;
            cout << p.apellido<< endl;
            cout << p.edad << endl;
        }
    }


    return 0;
}
