// Programacin en C++ para Ingenieros, Ed. Thomson Paraninfo, 2006
// Captulo 10: Ficheros



// Inclusin de libreras
#include <iostream.h>
#include <fstream.h>
// Para usar la instruccin 'exit'
#include <stdlib.h>
int main()
{
    // Fichero de entrada
    ifstream ficheroTexto1;
    char c;
    // Apertura fichero. No lo crea si no existe.
    ficheroTexto1.open ("texto.txt", ios::nocreate);
    if (ficheroTexto1.fail())
    {
    cout << "Error en la apertura del fichero texto.txt"
         << endl;
    exit(1);
    }

    // Comprobamos que el fichero no est vaco
    // Ponemos el flag de saltarse los espacios en blanco a falso
    ficheroTexto1.unsetf(ios::skipws);
    // Leemos todos los caracteres del fichero
    while (ficheroTexto1 >> c)
    {
        // Lo mostramos por pantalla
        cout << c;
    }    
    // Cerramos el fichero
    ficheroTexto1.close();
    return 0;
}
